;Coded by UEZ 2010-04-25
#include <GDIplus.au3>
#include <GUIConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
Opt("GUIOnEventMode", 1)

_GDIPlus_Startup()
Local $load_background = _GDIPlus_BitmapCreateFromFile("laughing_man_big_2_wo_text.png")
Local $load_foreground = _GDIPlus_BitmapCreateFromFile("laughing_man_big_2_text.png")
Local $width = _GDIPlus_ImageGetWidth($load_background)
Local $height = _GDIPlus_ImageGetHeight($load_background)

Local $dx = _GDIPlus_ImageGetWidth($load_foreground)
Local $dy = _GDIPlus_ImageGetHeight($load_foreground)
Local $scale = 1
Local $i

Local $hWnd = GUICreate("GDI+: Example by UEZ 2010", $width * $scale, $height * $scale, -1, -1, 0, $WS_EX_LAYERED + $WS_Ex_toolwindow)
GUISetOnEvent(-3, "_Exit")
GUISetState()

Local $hGraphics = _GDIPlus_GraphicsCreateFromHWND($hWnd)
Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphics)
Local $hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

Local $hFGBitmap = _GDIPlus_BitmapCreateFromGraphics($dx, $dy, $hGraphics)
Local $hFGBackbuffer = _GDIPlus_ImageGetGraphicsContext($hFGBitmap)

#region mache GUI transparent
$ScreenDc = _WinAPI_GetDC($hWnd)
$GDIBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmap)
$dc = _WinAPI_CreateCompatibleDC($ScreenDc)
_WinAPI_SelectObject($dc, $GDIBitmap)
; _WinAPI_UpdateLayeredWindow parameters
$tSize = DllStructCreate($tagSIZE)
$pSize = DllStructGetPtr($tSize)
DllStructSetData($tSize, "X", $width * $scale)
DllStructSetData($tSize, "Y", $height * $scale)
$tSource = DllStructCreate($tagPOINT)
$pSource = DllStructGetPtr($tSource)
$tBlend = DllStructCreate($tagBLENDFUNCTION)
$pBlend = DllStructGetPtr($tBlend)
Local $alpha = 255
DllStructSetData($tBlend, "Alpha", $alpha)
DllStructSetData($tBlend, "Format", 1)
$tPoint = DllStructCreate($tagPOINT)
$pPoint = DllStructGetPtr($tPoint)
DllStructSetData($tPoint, "X", 0)
DllStructSetData($tPoint, "Y", 0)
#endregion

Local $hMatrix = _GDIPlus_MatrixCreate()
Local $rot_mid_x = 512
Local $rot_mid_y = 512
_GDIPlus_MatrixTranslate($hMatrix, $rot_mid_x, $rot_mid_y)

$i = 0.5

While Sleep(30)
	_GDIPlus_GraphicsClear($hFGBackbuffer, 0xFF000000) ;lsche Hintergrund vom Bild (Schrift) Backbuffer

	_GDIPlus_MatrixRotate($hMatrix, $i, "False") ;drehe Bild (Schrift) im 2. Backbuffer
	_GDIPlus_GraphicsSetTransform($hFGBackbuffer, $hMatrix)
	_GDIPlus_GraphicsDrawImage($hFGBackbuffer, $load_foreground, -$rot_mid_x, -$rot_mid_y)

	_GDIPlus_GraphicsDrawImageRect($hBackbuffer, $hFGBitmap, 0, 0, $dx * $scale, $dy * $scale) ;kopiere Bild (Schrift) in den 1. Backbuffer

	_GDIPlus_GraphicsDrawImageRect($hBackbuffer, $load_background, 0, 0, $width * $scale, $height * $scale) ;kopiere 2. Bild (Vorderdrund) auf den Hintergrund

	$GDIBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmap) ;kopiere das gesamte Bild in die tranparente GUI
    _WinAPI_SelectObject($dc, $gdibitmap)
    _WinAPI_UpdateLayeredWindow($hWnd, $ScreenDc, 0, $pSize, $dc, $pSource, 0, $pBlend, 1)
	_WinAPI_DeleteObject($GDIBitmap)
WEnd

Func _Exit()
	_WinAPI_DeleteDC($dc)
    _WinAPI_ReleaseDC($hWnd, $ScreenDc)
	_GDIPlus_BitmapDispose($hFGBitmap)
	_GDIPlus_GraphicsDispose($hFGBackbuffer)
	_GDIPlus_MatrixDispose($hMatrix)
    _GDIPlus_BitmapDispose($hBitmap)
    _GDIPlus_GraphicsDispose($hBackbuffer)
    _GDIPlus_GraphicsDispose($hGraphics)
    _GDIPlus_Shutdown()
    Exit
EndFunc