;Coded by UEZ 2010-04-27
#include <GDIplus.au3>
#include <WindowsConstants.au3>
Opt("GUIOnEventMode", 1)

_GDIPlus_Startup()
Local $load_background = _GDIPlus_BitmapCreateFromFile("laughing_man_big_2_wo_text.png")
Local $load_foreground = _GDIPlus_BitmapCreateFromFile("laughing_man_big_2_text.png")
Local $width = _GDIPlus_ImageGetWidth($load_background)
Local $height = _GDIPlus_ImageGetHeight($load_background)

Local $dx = _GDIPlus_ImageGetWidth($load_foreground)
Local $dy = _GDIPlus_ImageGetHeight($load_foreground)
Local $i, $j
Local $scale = 1
Local $hWnd = GUICreate("GDI+: Example by UEZ", $width * $scale, $height * $scale, -1, -1, $WS_POPUP, $WS_EX_LAYERED)
GUISetBkColor(0)
_WinAPI_SetLayeredWindowAttributes($hWnd, 0)
GUISetOnEvent(-3, "_Exit")
GUISetState()

Local $hDC  = _WinAPI_GetWindowDC($hWnd)
Local $hGraphics = _GDIPlus_GraphicsCreateFromHDC($hDC)
Local $hBMP = _WinAPI_CreateBitmap($width, $height) ;create a dummy bitmap
Local $hImage = _GDIPlus_BitmapCreateFromHBITMAP($hBMP)
Local $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
Local $hScrDC  = _WinAPI_GetDC(0)
Local $hDC_backbuffer  = _WinAPI_CreateCompatibleDC($hScrDC)
Local $DC_obj = _WinAPI_SelectObject($hDC_backbuffer, $hBitmap)
Local $hBackbuffer = _GDIPlus_GraphicsCreateFromHDC($hDC_backbuffer)


Local $hDC2  = _WinAPI_GetWindowDC($hWnd)
Local $hGraphics2 = _GDIPlus_GraphicsCreateFromHDC($hDC)
Local $hBMP2 = _WinAPI_CreateBitmap($dx, $dy) ;create a dummy bitmap
Local $hImage2 = _GDIPlus_BitmapCreateFromHBITMAP($hBMP2)
Local $hFGBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage2)

Local $hDC_backbuffer2  = _WinAPI_CreateCompatibleDC($hScrDC)
Local $DC_obj2 = _WinAPI_SelectObject($hDC_backbuffer2, $hFGBitmap)
Local $hFGBackbuffer = _GDIPlus_GraphicsCreateFromHDC($hDC_backbuffer2)

Local $hMatrix = _GDIPlus_MatrixCreate()
_GDIPlus_MatrixTranslate($hMatrix, 512, 512)

$i = 0.5

$__RGB = True

While Sleep(30)
	_GDIPlus_GraphicsClear($hFGBackbuffer, 0x00FFFFFF)

	_GDIPlus_MatrixRotate($hMatrix, $i, 0) ;rotate foreground graphic
	_GDIPlus_GraphicsSetTransform($hFGBackbuffer, $hMatrix)
	_GDIPlus_GraphicsDrawImage($hFGBackbuffer, $load_foreground, -512, -512)

	_WinAPI_TransparentBlt($hDC_backbuffer, 0, 0, $dx * $scale, $dy * $scale, $hDC_backbuffer2, 0, 0, $dx, $dy, 0xFFFFFF) ;0xFFFFFF = transparent color
    _GDIPlus_GraphicsDrawImageRect($hBackbuffer, $load_background, 0, 0, $width * $scale, $height * $scale) ;draw background

	_WinAPI_BitBlt($hDC, 0, 0, $width, $height, $hDC_backbuffer, 0, 0, $MERGECOPY)
WEnd

Func _WinAPI_TransparentBlt($hDestDC, $iXDest, $iYDest, $iWidthDest, $iHeightDest, $hSrcDC, $iXSrc, $iYSrc, $iWidthSrc, $iHeightSrc, $iRGB)
	Local $Ret  = DllCall('gdi32.dll', 'int', 'GdiTransparentBlt', 'hwnd', $hDestDC, 'int', $iXDest, 'int', $iYDest, 'int', $iWidthDest, 'uint', $iHeightDest, 'hwnd', $hSrcDC, 'int', $iXSrc, 'int', $iYSrc, 'int', $iWidthSrc, 'int', $iHeightSrc, 'dword', __IsRGB($iRGB))
	If (@error) Or ($Ret[0] = 0) Then
		Return SetError(1, 0, 0)
	EndIf
	Return 1
EndFunc   ;==>_WinAPI_TransparentBlt

Func __IsRGB($iColor)
	If $__RGB Then
		$iColor = BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16))
	EndIf
	Return $iColor
EndFunc   ;==>__IsRGB

Func _Exit()
	_GDIPlus_ImageDispose($load_background)
	_GDIPlus_ImageDispose($load_foreground)
	_GDIPlus_MatrixDispose($hMatrix)

	_WinAPI_DeleteObject($hBMP2)
	_GDIPlus_BitmapDispose($hImage2)
	_GDIPlus_GraphicsDispose($hGraphics2)
	_WinAPI_DeleteObject($hFGBitmap)
	_WinAPI_SelectObject($hFGBackbuffer, $DC_obj2)
	_GDIPlus_GraphicsDispose($hFGBackbuffer)

	_WinAPI_DeleteObject($hBMP)
	_GDIPlus_BitmapDispose($hImage)
	_WinAPI_DeleteObject($hBitmap)
	_WinAPI_ReleaseDC(0, $hScrDC)
	_WinAPI_SelectObject($hDC_backbuffer, $DC_obj)
	_GDIPlus_GraphicsDispose($hBackbuffer)

    _GDIPlus_GraphicsDispose($hGraphics)
    _GDIPlus_Shutdown()
    Exit
EndFunc