;Coded by UEZ 2010-04-25
#include <GDIplus.au3>
#include <WindowsConstants.au3>
Opt("GUIOnEventMode", 1)

_GDIPlus_Startup()
Local $load_background = _GDIPlus_BitmapCreateFromFile("laughing_man_big_2_wo_text.png")
Local $load_foreground = _GDIPlus_BitmapCreateFromFile("laughing_man_big_2_text.png")
Local $width = _GDIPlus_ImageGetWidth($load_background)
Local $height = _GDIPlus_ImageGetHeight($load_background)

Local $dx = _GDIPlus_ImageGetWidth($load_foreground)
Local $dy = _GDIPlus_ImageGetHeight($load_foreground)
Local $scale = 0.5
Local $i, $sleep

Local $hWnd = GUICreate("GDI+: Example by UEZ", $width * $scale, $height * $scale, -1, -1, Default, $WS_EX_TOPMOST + $WS_EX_TOOLWINDOW)
GUISetOnEvent(-3, "_Exit")
GUISetState()

Local $hGraphics = _GDIPlus_GraphicsCreateFromHWND($hWnd)
Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphics)
Local $hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

Local $hFGBitmap = _GDIPlus_BitmapCreateFromGraphics($dx, $dy, $hGraphics)
Local $hFGBackbuffer = _GDIPlus_ImageGetGraphicsContext($hFGBitmap)

Local $hMatrix = _GDIPlus_MatrixCreate()
Local $rot_mid_x = 512
Local $rot_mid_y = 512
_GDIPlus_MatrixTranslate($hMatrix, $rot_mid_x, $rot_mid_y)

$i = 1
$sleep = 40

GUIRegisterMsg(0x0113, "_Draw") ;$WM_TIMER = 0x0113
DllCall("User32.dll", "int", "SetTimer", "hwnd", $hWnd, "int", 0, "int", $sleep, "int", 0)

Do
Until False * Not Sleep(100000)

Func _Draw()
	_GDIPlus_GraphicsClear($hFGBackbuffer, 0xFFFFFFFF)
	_GDIPlus_MatrixRotate($hMatrix, $i, "False") ;rotate foreground graphic
	_GDIPlus_GraphicsSetTransform($hFGBackbuffer, $hMatrix)
	_GDIPlus_GraphicsDrawImage($hFGBackbuffer, $load_foreground, -$rot_mid_x, -$rot_mid_y)
	_GDIPlus_GraphicsDrawImageRect($hBackbuffer, $hFGBitmap, 0, 0, $dx, $dy) ;copy foreground backbuffer to main backbuffer

	_GDIPlus_GraphicsDrawImage($hBackbuffer, $load_background, 0, 0) ;draw background
	_GDIPlus_GraphicsDrawImageRect($hGraphics, $hBitmap, 0, 0, $width * $scale, $height * $scale) ;copy full drawn image to main screen
EndFunc

Func _Exit()
	GUIRegisterMsg(0x0113, "")
	_GDIPlus_BitmapDispose($hFGBitmap)
	_GDIPlus_GraphicsDispose($hFGBackbuffer)
	_GDIPlus_MatrixDispose($hMatrix)
    _GDIPlus_BitmapDispose($hBitmap)
    _GDIPlus_GraphicsDispose($hBackbuffer)
    _GDIPlus_GraphicsDispose($hGraphics)
    _GDIPlus_Shutdown()
	GUIDelete($hwnd)
    Exit
EndFunc